package org.eclipse.mylar.zest.layouts.algorithms;

import java.awt.Dimension;

import org.eclipse.mylar.zest.layouts.dataStructures.InternalNode;
import org.eclipse.mylar.zest.layouts.dataStructures.InternalRelationship;

import edu.uci.ics.jung.visualization.SpringLayout;

public class JungSpringLayout extends AbstractJungLayout {

	
	public static final int TOTAL_STEPS = 1000;
	private int step = 0;

	public JungSpringLayout(int styles) {
		super(styles);
	}

	protected void applyLayoutInternal(InternalNode[] entitiesToLayout,
			InternalRelationship[] relationshipsToConsider, double boundsX,
			double boundsY, double boundsWidth, double boundsHeight) {
		layout = new SpringLayout(graph);
		layout.initialize(new Dimension((int)boundsWidth, (int)boundsHeight));
		SpringLayout springLayout = (SpringLayout)layout;
		while ( springLayout.incrementsAreDone() == false && step < TOTAL_STEPS) {
			this.fireProgressEvent(step, TOTAL_STEPS);
			springLayout.advancePositions();
			step++;
		}
	}
	
	protected int getCurrentLayoutStep() {
		return step;
	}
	
	protected int getTotalNumberOfLayoutSteps() {

		return TOTAL_STEPS;
	}

}
